const dialog = document.getElementById('myDialog');
const showDialogButton = document.getElementById('showDialogButton');
const closeDialogButton = document.getElementById('closeDialog');
const showToolbar = document.getElementById('showToolbar');
const emptylst = document.getElementById('emptylst');

document.getElementById("file_path").innerText = "file://~".substring(7);

emptylst.addEventListener('click', () => {
	$.getJSON("/requests/status.json?command=pl_empty", function(data) {
		console.info("empty list");
		dialog.close();
		location.reload();
	});
});

showToolbar.addEventListener('click', () => {
	var oDiv = document.getElementById("myToolbar");
	var aDisplay = oDiv.style.display;
	if("none" == aDisplay){
		oDiv.style.display = "block";
	}else{
		oDiv.style.display = "none";
	}
});

showDialogButton.addEventListener('click', () => {
	$.getJSON("/requests/browse.json?uri=file://~", function(data) {
		const vlcPlaylist = data.element;
		vlcPlaylist.forEach((item) => { //利用foreach循环遍历
			const clone = $("#file_node").clone();
			//console.info(item.name);
			if (item.type === "dir") {
				clone.find("span").attr("class", "dir_type");
			} else if (item.type === "file") {
				clone.find("span").attr("class", "file_type");
			} else {
				return;
			}
			clone.find(".file_name").text(item.name);
			clone.attr("type", item.type);
			clone.attr("uri", item.uri);
			clone.css("display", "block");
			clone.appendTo("#file_container");
		});
	});
	dialog.showModal();
});

closeDialogButton.addEventListener('click', () => {
	$("#file_container").empty();
	dialog.close();
});

function file_click(obj) {
	var uri = obj.getAttribute("uri");
	var ftype = obj.getAttribute("type");
	//console.info(ftype);
	$("#file_container")
		.empty();
	if (ftype === "dir") {
		document.getElementById("file_path")
			.innerText = decodeURI(uri.substring(8));
		$.getJSON("/requests/browse.json?uri=" + uri, function(data) {
			const vlcPlaylist = data.element;
			vlcPlaylist.forEach((item) => { //利用foreach循环遍历
				const clone = $("#file_node").clone();
				if (item.type === "dir") {
					clone.find("span").attr("class", "dir_type");
				} else if (item.type === "file") {
					clone.find("span").attr("class", "file_type");
				} else {
					return;
				}
				clone.find(".file_name").text(item.name);
				clone.attr("type", item.type);
				clone.attr("uri", item.uri);
				clone.css("display", "block");
				clone.appendTo("#file_container");
			});
		});
	} else {
		// /requests/status.xml?command=in_play&input=file%3A%2F%2F%2FC%3A%2Fos848618.bin
		//  add <mrl> to playlist and start playback:  ?command=in_play&input=<mrl>
		// 命令参考文档  https://wiki.videolan.org/VLC_HTTP_requests/
		console.info("file click");
		$.getJSON("/requests/status.json?command=in_enqueue&input=" + uri, function(data) {
			console.info("addlist");
			dialog.close();
			location.reload();
		});
	}
};
//导出函数
window.file_click = file_click;